function par=ParamEst(y,X,Z,l,Est,alpha)


N  = size(y,1);

M  = FirstStageMallows(X,Z,l);
ZS = Z;
Z  = Z(:,1:M);

Pi = X\Z;
Xh = Z*Pi';
u  = X-Xh;
H  = Xh'*Xh/N;
Hi = inv(H);

switch Est
    case '2SLS'
        beta = TSLS(y,X,Z);
    case 'LIML'
        beta = LIML(y,X,Z);
    case 'Fuller'
        beta = Fuller(y,X,Z,alpha);
end

e  = y-X*beta;
se = e'*e/N;
ul = u*inv(H)*l;
sl = ul'*ul/N;
sle= ul'*e/N;

a  = sle^2;
b  = se*sl+sle^2;
if size(beta,1)==1
    B = 2*(se*sl+4*sle^2);
else
    B = l'*Hi*CompBn(u,e,se,Xh,H)*Hi*l;
end
Z   = ZS;
M   = size(Z,2);
PM  = Z*inv(Z'*Z)*Z';
ul  = zeros(M,N);
ulDN= zeros(M,N);

for i=1:M;
    Zm        = Z(:,1:i);
    Pm        = Zm*inv(Zm'*Zm)*Zm';
    ul(i,:)   = ((PM-Pm)*X*Hi*l)';
    ulDN(i,:) = ((eye(N)-Pm)*X*Hi*l)';
end

U   = ul*ul';
UDN = ulDN*ulDN';

par.a   = a;
par.b   = b;
par.B   = B;
par.se  = se;
par.sl  = sl;
par.sle = sle;
par.U   = U;
par.UDN = UDN;
par.Ualt= ul;
par.Utilde = ulDN;
end





